Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -324,48 +432,7 @@
     END TYPE t_wall_vertical
 
-!-- arrays for calculation of svf and csf
-    TYPE(t_svf), DIMENSION(:), POINTER             ::  asvf             !< pointer to growing svc array
-    TYPE(t_csf), DIMENSION(:), POINTER             ::  acsf             !< pointer to growing csf array
-    TYPE(t_svf), DIMENSION(:), ALLOCATABLE, TARGET ::  asvf1, asvf2     !< realizations of svf array
-    TYPE(t_csf), DIMENSION(:), ALLOCATABLE, TARGET ::  acsf1, acsf2     !< realizations of csf array
-    INTEGER(iwp)                                   ::  nsvfla           !< dimmension of array allocated for storage of svf in local processor
-    INTEGER(iwp)                                   ::  ncsfla           !< dimmension of array allocated for storage of csf in local processor
-    INTEGER(iwp)                                   ::  msvf, mcsf       !< mod for swapping the growing array
-    INTEGER(iwp), PARAMETER                        ::  gasize = 10000   !< initial size of growing arrays
-!-- temporary arrays for calculation of csf in raytracing
-    INTEGER(iwp)                                   ::  maxboxesg        !< max number of boxes ray can cross in the domain
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  boxes            !< coordinates of gridboxes being crossed by ray
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  crlens           !< array of crossing lengths of ray for particular grid boxes
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  lad_ip           !< array of numbers of process where lad is stored 
-#if defined( __parallel )
-    INTEGER(kind=MPI_ADDRESS_KIND), &
-                  DIMENSION(:), ALLOCATABLE        ::  lad_disp         !< array of displaycements of lad in local array of proc lad_ip
-#endif
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  lad_s_ray        !< array of received lad_s for appropriate gridboxes crossed by ray 
-
-!-- arrays storing the values of USM
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  svfsurf          !< svfsurf[:,isvf] = index of source and target surface for svf[isvf]
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  svf              !< array of shape view factors+direct irradiation factors for local surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins          !< array of sw radiation falling to local surface after i-th reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl          !< array of lw radiation for local surface after i-th reflection
-    
-                                                                        !< Inward radiation is also valid for virtual surfaces (radiation leaving domain)
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw         !< array of sw radiation falling to local surface including radiation from reflections
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlw         !< array of lw radiation falling to local surface including radiation from reflections
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdir      !< array of direct sw radiation falling to local surface
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdif      !< array of diffuse sw radiation from sky and model boundary falling to local surface
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlwdif      !< array of diffuse lw radiation from sky and model boundary falling to local surface
-    
-                                                                        !< Outward radiation is only valid for nonvirtual surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsl        !< array of reflected sw radiation for local surface in i-th reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutll        !< array of reflected + emitted lw radiation for local surface in i-th reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfouts         !< array of reflected sw radiation for all surfaces in i-th reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutl         !< array of reflected + emitted lw radiation for all surfaces in i-th reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsw        !< array of total sw radiation outgoing from nonvirtual surfaces surfaces after all reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutlw        !< array of total lw radiation outgoing from nonvirtual surfaces surfaces after all reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf           !< array of total radiation flux incoming to minus outgoing from local surface
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_l        !< local copy of rad_net (net radiation at surface)
 
 !-- arrays for time averages
+!-- Attention: the variable rad_net_av is also used in the 3d field variable in radiation_model_mod.f90. It may be better to rename it 
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rad_net_av       !< average of rad_net_l
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw_av      !< average of sw radiation falling to local surface including radiation from reflections
@@ -381,25 +448,12 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl_av       !< average of array of residua of lw radiation absorbed in surface after last reflection
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface  
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_av       !< average of wghf_eb
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wshf_eb_av       !< average of wshf_eb
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_wall_av        !< Average of t_wall
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_green_av !< average of wghf_eb_green
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_green_av       !< Average of t_green
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_window_av !< average of wghf_eb_window
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_window_av      !< Average of t_window    
     
-!-- block variables needed for calculation of the plant canopy model inside the urban surface model
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  csfsurf          !< csfsurf[:,icsf] = index of target surface and csf grid index for csf[icsf]
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  csf              !< array of plant canopy sink fators + direct irradiation factors (transparency)
-                                                                        !< for local surfaces
-    INTEGER(wp), DIMENSION(:,:), ALLOCATABLE       ::  pcbl             !< k,j,i coordinates of l-th local plant canopy box pcbl[:,l] = [k, j, i]
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE    ::  gridpcbl         !< index of local pcb[k,j,i]
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw          !< array of absorbed sw radiation for local plant canopy box
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw          !< array of absorbed lw radiation for local plant canopy box
-    INTEGER(iwp)                                   ::  npcbl            !< number of the plant canopy gridboxes in local processor
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pch              !< heights of the plant canopy
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  pct              !< top layer of the plant canopy
-    REAL(wp), DIMENSION(:,:,:), POINTER            ::  usm_lad          !< subset of lad_s within urban surface, transformed to plain Z coordinate
-    REAL(wp), DIMENSION(:), POINTER                ::  usm_lad_g        !< usm_lad globalized (used to avoid MPI RMA calls in raytracing)
-    REAL(wp)                                       ::  prototype_lad    !< prototype leaf area density for computing effective optical depth
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterr, plantt   !< temporary global arrays for raytracing
-    
-!-- radiation related arrays (it should be better in interface of radiation module of PALM
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_dir    !< direct sw radiation
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_sw_in_diff   !< diffusion sw radiation
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  rad_lw_in_diff   !< diffusion lw radiation
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -419,8 +473,19 @@
     REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
                                                                          !< normalized soil, wall and roof layer depths (m/m)
+!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default = (/0.33_wp, 0.66_wp, 1.0_wp /)
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.25_wp, 0.5_wp, 0.75_wp, 1.0_wp /)
+!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.33_wp, 0.66_wp, 1.0_wp /)
+!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
+                                                                         !< normalized window layer depths (m/m)
+!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
+                                                                         !< normalized green layer depths (m/m)
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.25_wp, 0.5_wp, 0.75_wp, 1.0_wp /)
+!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.33_wp, 0.66_wp, 1.0_wp /)
+
                                                                         
     REAL(wp)                                       ::   wall_inner_temperature = 296.0_wp    !< temperature of the inner wall surface (~23 degrees C) (K)
     REAL(wp)                                       ::   roof_inner_temperature = 296.0_wp    !< temperature of the inner roof surface (~23 degrees C) (K)
     REAL(wp)                                       ::   soil_inner_temperature = 283.0_wp    !< temperature of the deep soil (~10 degrees C) (K)
+    REAL(wp)                                       ::   window_inner_temperature = 296.0_wp  !< temperature of the inner window surface (~23 degrees C) (K)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -428,28 +493,84 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn                !< normalized wall layer depths (m)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn_window         !< normalized window layer depths (m)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn_green          !< normalized green layer depths (m)
 
 #if defined( __nopointer )
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h           !< wall surface temperature (K) at horizontal walls
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_p         !< progn. wall surface temperature (K) at horizontal walls
-
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h    !< window surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_p  !< progn. window surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_h     !< green surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_h_p   !< progn. green surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_whole_h     !< whole surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_whole_h_p   !< progn. whole surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h      !< near surface temperature (10cm) (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h_p    !< progn. near surface temperature (10cm) (K) at horizontal walls
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v_p
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v_p
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_green_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_green_v_p
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_whole_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_whole_v_p
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_10cm_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_10cm_v_p
 #else
     REAL(wp), DIMENSION(:), POINTER                :: t_surf_h
     REAL(wp), DIMENSION(:), POINTER                :: t_surf_h_p 
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_window_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_window_h_p 
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_green_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_green_h_p 
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_whole_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_whole_h_p 
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_10cm_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_10cm_h_p
 
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_1
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_2
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_2
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_h_2
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_whole_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_whole_h_2
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h_2
 
     TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v
     TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_green_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_green_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_whole_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_whole_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_10cm_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_10cm_v_p
 
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_1
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_2
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_window_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_window_v_2
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_green_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_green_v_2
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_whole_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_whole_v_2
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_10cm_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_10cm_v_2
+    
 #endif
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_av          !< average of wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_av   !< average of window surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_av    !< average of green wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_whole_av    !< average of whole wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_av    !< average of whole wall surface temperature (K)
 
 !-- Temporal tendencies for time stepping            
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_m       !< surface temperature tendency (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_m       !< surface temperature tendency of wall (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_window_m !< surface temperature tendency of window (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_green_m !< surface temperature tendency of green wall (K)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -457,7 +578,4 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !-- parameters of the land, roof and wall surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: albedo_surf        !< albedo of the surface
-!-- parameters of the wall surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: emiss_surf         !< emissivity of the wall surface
 
 #if defined( __nopointer )
@@ -465,18 +583,40 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_av          !< Average of t_wall
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_p           !< Prog. wall temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h           !< Window temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_av        !< Average of t_window
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_p         !< Prog. window temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h            !< Green temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_av         !< Average of t_green
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_p          !< Prog. green temperature (K)
 
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v             !< Wall temperature (K)
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av          !< Average of t_wall
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_p           !< Prog. wall temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v           !< Window temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_av        !< Average of t_window
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_p         !< Prog. window temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v            !< Green temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_av         !< Average of t_green
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_p          !< Prog. green temperature (K)
 #else
     REAL(wp), DIMENSION(:,:), POINTER                :: t_wall_h, t_wall_h_p
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_av, t_wall_h_1, t_wall_h_2
+    REAL(wp), DIMENSION(:,:), POINTER                :: t_window_h, t_window_h_p
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_av, t_window_h_1, t_window_h_2
+    REAL(wp), DIMENSION(:,:), POINTER                :: t_green_h, t_green_h_p
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_av, t_green_h_1, t_green_h_2
 
     TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_wall_v, t_wall_v_p
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av, t_wall_v_1, t_wall_v_2
+    TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_window_v, t_window_v_p
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_av, t_window_v_1, t_window_v_2
+    TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_green_v, t_green_v_p
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_av, t_green_v_1, t_green_v_2
 #endif
 
 !-- Wall temporal tendencies for time stepping
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_wall_m          !< t_wall prognostic array 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_window_m        !< t_window prognostic array 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_green_m         !< t_green prognostic array 
 
 !-- Surface and material parameters classes (surface_type)
@@ -495,8 +635,11 @@
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_type_codes   !< codes of wall types
     REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: surface_params       !< parameters of wall types
-    
-    CHARACTER(len=*), PARAMETER                    :: svf_file_name='usm_svf'
+
     
 !-- interfaces of subroutines accessed from outside of this module
+    INTERFACE usm_boundary_condition
+       MODULE PROCEDURE usm_boundary_condition
+    END INTERFACE usm_boundary_condition
+
     INTERFACE usm_check_data_output
        MODULE PROCEDURE usm_check_data_output
@@ -523,12 +666,16 @@
     END INTERFACE usm_material_heat_model
     
+    INTERFACE usm_green_heat_model
+       MODULE PROCEDURE usm_green_heat_model
+    END INTERFACE usm_green_heat_model
+    
     INTERFACE usm_parin
        MODULE PROCEDURE usm_parin
     END INTERFACE usm_parin
-
-    INTERFACE usm_radiation
-       MODULE PROCEDURE usm_radiation
-    END INTERFACE usm_radiation
     
+    INTERFACE usm_temperature_near_surface
+       MODULE PROCEDURE usm_temperature_near_surface
+    END INTERFACE usm_temperature_near_surface
+
     INTERFACE usm_read_restart_data 
        MODULE PROCEDURE usm_read_restart_data
@@ -546,4 +693,13 @@
        MODULE PROCEDURE usm_write_restart_data
     END INTERFACE usm_write_restart_data
+
+    INTERFACE usm_allocate_surface
+       MODULE PROCEDURE usm_allocate_surface
+    END INTERFACE usm_allocate_surface
+
+    INTERFACE usm_average_3d_data
+       MODULE PROCEDURE usm_average_3d_data
+    END INTERFACE usm_average_3d_data
+
     
     SAVE
@@ -551,22 +707,20 @@
     PRIVATE 
     
+!-- Public functions
+    PUBLIC usm_boundary_condition, usm_check_parameters, usm_init_urban_surface,&
+           usm_read_restart_data,                                               & 
+           usm_surface_energy_balance, usm_material_heat_model,                 &
+           usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,      &
+           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,               &
+           usm_write_restart_data, usm_allocate_surface
+
 !-- Public parameters, constants and initial values
-    PUBLIC split_diffusion_radiation,                                          &
-           usm_anthropogenic_heat, usm_material_model, mrt_factors,            &
-           usm_check_parameters,                                               &
-           usm_energy_balance_land, usm_energy_balance_wall, nrefsteps,        &
-           usm_init_urban_surface, usm_radiation, usm_read_restart_data,       &
-           usm_surface_energy_balance, usm_material_heat_model,                &
-           usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,     &
-           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,              &
-           usm_write_restart_data,                                             &
-           nzub, nzut, ra_horiz_coef, usm_lad_rma,                             &
-           land_category, pedestrant_category, wall_category, roof_category,   &
-           write_svf_on_init, read_svf_on_init
+    PUBLIC usm_anthropogenic_heat, usm_material_model, ra_horiz_coef,           &
+           usm_green_heat_model, usm_temperature_near_surface
+
 
 
  CONTAINS
 
- 
 !------------------------------------------------------------------------------!
 ! Description:
